// $Id: findfuncs.c,v 1.3 2008/01/21 15:30:11 hochoa Exp $

/*
 * findfuncs.c
 *
 * Description: 
 *
 * Author: Hernan Ochoa (hochoa@coresecurity.com) (hernan@gmail.com)
 *
 * Copyright (c) 2007-2008 Hernan Ochoa, Buenos Aires, Argentina.
 * All rights reserved.
 *
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES
 * ARE DISCLAIMED. IN NO EVENT SHALL CORE SDI S.A. BE LIABLE FOR ANY
DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY OR CONSEQUENTIAL DAMAGES
 * RESULTING FROM THE USE OR MISUSE OF ANY RECOMPILATION OF THIS SOURCE
 * CODE NOT PROVIDED BY CORE SDI S.A.
 **/
#include <windows.h>
#include "findfuncs.h"


BYTE LSAEM_Block1[] = {
	0x8B, 0xFF,
	0x55,
	0x8B, 0xEC,
	0x81, 0xEC, 0x10, 0x01, 0x00, 0x00
};
// +5
BYTE LSAEM_Block2[] = {
	0x56,
	0x8B, 0x75, 0x08,
	0x85, 0xF6,
	0x89, 0x45, 0xFC,
	0x57,
	0x74, 0x53,
	0x53,
	0x8B, 0x5D, 0x0C,
	0x85, 0xDB,
	0x74, 0x4A,
	0xF6, 0xC3, 0x07,
};
// +11
BYTE LSAEM_Block3[] = {
	0x89, 0x85, 0xF0, 0xFE, 0xFF, 0xFF
};
//+5
BYTE LSAEM_Block4[] = {
	0xC1, 0xEB, 0x03,
	0x8B, 0xFB,
	0x89, 0x85, 0xF4, 0xFE, 0xFF, 0xFF,
	0x74, 0x24,
	0x8D, 0x85, 0xF0, 0xFE, 0xFF, 0xFF,
	0x50,
	0xFF, 0x75, 0x10
};


BYTE LSAAC_Block1[] = {
	0x8B, 0xFF,
	0x55,
	0x8B, 0xEC,
	0x51,
	0xFF, 0x75, 0x08
};
//+5
BYTE LSAAC_Block2[] = {
	0x85, 0xC0,
	0x89, 0x45, 0x08
};
//+6
BYTE LSAAC_Block3[] = {
	0x8B, 0x45, 0x10,
	0x8B, 0x4D, 0x14,
	0x53,
	0x56,
	0x57,
	0x33, 0xFF,
	0x66, 0x8B, 0x38,
	0x33, 0xDB,
	0x66, 0x8B, 0x19,
	0x66, 0x83, 0xC7, 0x08,
	0x66, 0x83, 0xC3, 0x08,
	0xB8, 0xF8, 0xFF, 0x00, 0x00,
	0x23, 0xF8,
	0x23, 0xD8,
	0x0F, 0xB7, 0xC7,
	0x0F, 0xB7, 0xCB,
	0x89, 0x45, 0xFC,
	0x8D, 0x44, 0x01, 0x14,
	0x50
};
//+15
BYTE LSAAC_Block4[] = {
	0x8B, 0x4D, 0xFC,
	0xFF, 0x75, 0x10,
	0x8D, 0x46, 0x14,
	0x89, 0x46, 0x08,
	0x03, 0xC1,
	0x89, 0x46, 0x10,
	0x8D, 0x46, 0x04,
	0x66, 0x89, 0x7E, 0x06
};


BOOL isEM( BYTE* pFunc)
{
BYTE* pLSAMem;
BYTE* pPtr;
unsigned int len, blockSize;
int nRet;

	//Load LSASRV.DLL
	pLSAMem = (BYTE*)LoadLibrary("LSASRV.DLL");
	if( pLSAMem == (char*)NULL || pLSAMem == (char*)0xFFFFFFFF ) 
			return FALSE;

	len = sizeof(LSAEM_Block1) + 5 + sizeof(LSAEM_Block2) + 11 +sizeof(LSAEM_Block3) + 5 + sizeof(LSAEM_Block4);

	if( IsBadReadPtr( pFunc, len ) == TRUE ) {
		return FALSE;
	}

	blockSize = sizeof(LSAEM_Block1);	
	pPtr = (BYTE*)pFunc;
	nRet = memcmp( pPtr, &LSAEM_Block1[0], blockSize );

	if( nRet != 0 ) return FALSE;	

	blockSize = sizeof(LSAEM_Block2);
	pPtr = (BYTE*) (pFunc+sizeof(LSAEM_Block1)+5);
	nRet = memcmp( pPtr, &LSAEM_Block2[0], blockSize );

	if( nRet != 0 ) return FALSE;

	blockSize = sizeof(LSAEM_Block3);
	pPtr = (BYTE*) (pFunc+sizeof(LSAEM_Block1)+5+sizeof(LSAEM_Block2)+11);
	nRet = memcmp( pPtr, &LSAEM_Block3[0], blockSize );

	if( nRet != 0 ) return FALSE;

	blockSize = sizeof(LSAEM_Block4);
	pPtr = (BYTE*) (pFunc+sizeof(LSAEM_Block1)+5+sizeof(LSAEM_Block2)+11+sizeof(LSAEM_Block3)+5);
	nRet = memcmp( pPtr, &LSAEM_Block4[0], blockSize );

	if( nRet != 0 ) return FALSE;

	return TRUE;

}

BOOL isAC( BYTE* pFunc )
{
BYTE* pLSAMem;
BYTE* pPtr;
unsigned int len, blockSize;
int nRet;

	//Load LSASRV.DLL
	pLSAMem = (BYTE*)LoadLibrary("LSASRV.DLL");
	if( pLSAMem == (char*)NULL || pLSAMem == (char*)0xFFFFFFFF ) 
			return FALSE;

	// is it valid?
	len = sizeof(LSAAC_Block1) + 5 + sizeof(LSAAC_Block2) + 6 + sizeof(LSAAC_Block3) + 15 + sizeof(LSAAC_Block4);
	if( IsBadReadPtr( pFunc, len ) == TRUE ) {
		return FALSE;
	}

	blockSize = sizeof(LSAAC_Block1);	
	pPtr = (BYTE*)pFunc;
	nRet = memcmp( pPtr, &LSAAC_Block1[0], blockSize );

	if( nRet != 0 ) return FALSE;

	blockSize = sizeof(LSAAC_Block2);
	pPtr = (BYTE*) (pFunc+sizeof(LSAAC_Block1)+5);
	nRet = memcmp( pPtr, &LSAAC_Block2[0], blockSize);

	if( nRet != 0 ) return FALSE;

	blockSize = sizeof(LSAAC_Block3);
	pPtr = (BYTE*) (pFunc+sizeof(LSAAC_Block1)+5+sizeof(LSAAC_Block2)+6);
	nRet = memcmp( pPtr, &LSAAC_Block3[0], blockSize);

	if( nRet != 0 ) return FALSE;

	blockSize = sizeof(LSAAC_Block4);
	pPtr = (BYTE*) (pFunc+sizeof(LSAAC_Block1)+5+sizeof(LSAAC_Block2)+6+sizeof(LSAAC_Block3)+15);
	nRet = memcmp( pPtr, &LSAAC_Block4[0], blockSize);

	if( nRet != 0 ) return FALSE;

	return TRUE;

}


// Input:
// 		ppAddressGroup = pointer to AddressGroup that will be returned by the function 
// 
// Returns:
// 		FALSE = if couldn't find any of the addresses.
// 		TRUE  = both addresses where found.
BOOL findFuncs(AddressesGroup *pOutAddressGroup)
{
BYTE* pLSAMem;
BYTE* pFunc;
unsigned int n;
BOOL bFound;


	if( pOutAddressGroup == NULL )
			return FALSE;


	bFound = FALSE;	
	// Find Addresses
	for(n =0; _AddrGroups[n] != NULL; n++) {

		// zero-out the AddressGroup
		memset(pOutAddressGroup, '\0', sizeof(AddressesGroup));

		// Find AC Address
		pFunc = _AddrGroups[n]->pAddCredential;
		if( isAC( pFunc ) == TRUE ) {
			pOutAddressGroup->pAddCredential = pFunc;
		}

		// Find EM Address
		pFunc = _AddrGroups[n]->pEncryptMemory;
		if( isEM( pFunc ) == TRUE ) {
			pOutAddressGroup->pEncryptMemory = pFunc;
		}

		// If we found both addresses, then return all the other addresses as well
		if( pOutAddressGroup->pAddCredential != NULL && pOutAddressGroup->pEncryptMemory != NULL ) {

				// copy AddressGroup
				memcpy(pOutAddressGroup, _AddrGroups[n], sizeof(AddressesGroup));
				// Done, we found the thing
				bFound = TRUE;
				break;

		}
	}

		
	return bFound;
}


