// $Id: iamdll.h,v 1.3 2008/01/21 15:31:10 hochoa Exp $

/*
 * iamdll.h
 *
 * Description: 
 *
 * Author: Hernan Ochoa (hochoa@coresecurity.com) (hernan@gmail.com)
 *
 * Copyright (c) 2007-2008 Hernan Ochoa, Buenos Aires, Argentina.
 * All rights reserved.
 *
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES
 * ARE DISCLAIMED. IN NO EVENT SHALL CORE SDI S.A. BE LIABLE FOR ANY
DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY OR CONSEQUENTIAL DAMAGES
 * RESULTING FROM THE USE OR MISUSE OF ANY RECOMPILATION OF THIS SOURCE
 * CODE NOT PROVIDED BY CORE SDI S.A.
 **/


#ifndef _IAM_DLL_H_
#define _IAM_DLL_H_

#include <windows.h>
#include <stdio.h>

typedef HINSTANCE (WINAPI *pLoadLib_t) (CHAR *);
typedef HINSTANCE (WINAPI *pGetProcAddr_t) (HINSTANCE, CHAR *);
typedef HINSTANCE (WINAPI *pFreeLib_t) (HINSTANCE);

#pragma pack(1)
struct STRING_t {
	unsigned short int len;
	unsigned short int maxlen;
	char *buffer;
};

struct LUID_t {
	unsigned long low;
	unsigned long high;
};



struct CREDENTIALS_t {

	struct STRING_t	domain;
	struct STRING_t name;
	unsigned char	nthash[16];
	unsigned char	lmhash[16];
	char	domainbuffer[100];
	char 	namebuffer[100];	
};

struct CREDENTIALS_wrapper2 {
	struct STRING_t credentialsRef;
	struct CREDENTIALS_t credentials;
};

struct CREDENTIALS_wrapper {

	struct STRING_t primaryRef;
	struct STRING_t credentialsRef;
	unsigned char buffer[8];
	struct CREDENTIALS_t credentials;
};

typedef struct _REMOTE_INFO {
	pLoadLib_t pLoadLibrary;
	pGetProcAddr_t pGetProcAddress;
	pFreeLib_t pFreeLibrary;
	CHAR szDllName[MAX_PATH+1];
	CHAR szProcName[MAX_PATH+1];
	CHAR szPipeName[MAX_PATH+1];
	int logonid;
	DWORD dwDLL_MS;
	DWORD dwDLL_LS;
	DWORD useAddresses;
	DWORD AC_Address;
	DWORD EM_Address;
	char  szNewName[MAX_PATH+1];
	struct CREDENTIALS_t creds;
} REMOTE_INFO;

typedef int (*pGenFunc_t) (REMOTE_INFO*);

#endif /* _IAM_DLL_H_ */
