#include <windows.h>
#include <stdio.h>
#include <psapi.h>

#include "findfuncs_msv10.h"

/*
 * findfuncs_msv10.c
 *
 * Description:  findfuncs_msv10.c
 *
 * Author: Hernan Ochoa (hochoa@coresecurity.com) (hernan@gmail.com)
 *
 * Copyright (c) 2007-2008 Hernan Ochoa, Buenos Aires, Argentina.
 * All rights reserved.
 *
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES
 * ARE DISCLAIMED. IN NO EVENT SHALL CORE SDI S.A. BE LIABLE FOR ANY
DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY OR CONSEQUENTIAL DAMAGES
 * RESULTING FROM THE USE OR MISUSE OF ANY RECOMPILATION OF THIS SOURCE
 * CODE NOT PROVIDED BY CORE SDI S.A.
 **/



BOOL findNlpDeletePrimaryCredential(BYTE *pMemory)
{

//8B FF		mov     edi, edi
//55		push    ebp
//8B EC		mov     ebp, esp
//51		push    ecx
//51		push    ecx
//68 5C 40 C7 77	push    offset aPrimary ; "Primary"
static BYTE *segment1_del = "\x8B\xFF\x55\x8B\xEC\x51\x51\x68";
unsigned int segment1_del_len = 8;
BYTE *primaryString = "Primary";
unsigned int primaryStringLen = 7;
BYTE *pPrimaryPtr;
BYTE *pMem;

	// Find First Code Segment
	pMem = pMemory;
	if( IsBadReadPtr( pMem, segment1_del_len) == TRUE ) return FALSE;
	if( memcmp( pMem, segment1_del, segment1_del_len) != 0) return FALSE;
	
	printf("\tsegment 1 found at %.8Xh\n", pMem);

	// Make sure that the address in
	// push    offset aPrimary ; "Primary"
	//is really pointing to a "Primary" string
	pPrimaryPtr = (BYTE*) *((DWORD*)(pMemory+segment1_del_len));
	if( memcmp(pPrimaryPtr, primaryString, primaryStringLen) != 0 )
	{
		printf("\t\"Primary\" string not found!\n");
		return FALSE;
	}
	
	printf("\t\"Primary\" string found at %.8Xh\n", (DWORD)pPrimaryPtr);

	return TRUE;
}

BOOL findNlpAddPrimaryCredential(BYTE *pMemory)
{
//8B FF             mov     edi, edi
//55                push    ebp
//8B EC             mov     ebp, esp
//83 EC 10          sub     esp, 10h
//56                push    esi
//8B 75 0C          mov     esi, [ebp+arg_4]
//8D 46 08          lea     eax, [esi+8]
//50                push    eax
//56                push    esi
//E8 55 00 00 00    call    _NlpMakeRelativeString@8 ; NlpMakeRelativeString(x,x)
static BYTE *segment1_add = "\x8B\xFF\x55\x8B\xEC\x83\xEC\x10\x56\x8B\x75\x0C\x8D\x46\x08\x50\x56\xE8";
unsigned int segment1_add_len = 18;
BYTE *pMem;


	// Find First Code Segment
	pMem = pMemory;
	if( IsBadReadPtr( pMem, segment1_add_len) == TRUE ) return FALSE;
	if( memcmp( pMem, segment1_add, segment1_add_len) != 0) return FALSE;
	
	printf("\tsegment 1 found at %.8Xh\n", pMem);
	
	return TRUE;

}

BOOL findNlpGetPrimaryCredential(BYTE *pMemory)
{
	
//8B FF                      mov     edi, edi
//55                         push    ebp
//8B EC                      mov     ebp, esp
//83 EC 18                   sub     esp, 18h
//83 65 FC 00                and     [ebp+var_4], 0
//68 5C 40 C7 77             push    offset aPrimary ; "Primary"
static BYTE *segment1_get = "\x8B\xFF\x55\x8B\xEC\x83\xEC\x18\x83\x65\xFC\x00\x68";
unsigned int segment1_get_len = 13;
//8D 45 F0                   lea     eax, [ebp+var_10]
//50                         push    eax
//8D 45 F8                   lea     eax, [ebp+var_8]
//50                         push    eax
//8D 45 E8                   lea     eax, [ebp+var_18]
//50                         push    eax
//6A 00                      push    0
//8D 45 FC                   lea     eax, [ebp+var_4]
//50                         push    eax
static BYTE *segment2_get = "\x8D\x45\xF0\x50\x8D\x45\xF8\x50\x8D\x45\xE8\x50\x6A\x00\x8D\x45\xFC\x50";
unsigned int segment2_get_len = 18;
BYTE *primaryString = "Primary";
unsigned int primaryStringLen = 7;
BYTE *pPrimaryPtr;
BYTE *pMem;
BOOL bRet;
unsigned int n;
BYTE *pSegment2;
BYTE *ddAddr1;

	
	
	
	// Find First Code Segment
	pMem = pMemory;
	if( IsBadReadPtr( pMem, segment1_get_len) == TRUE ) return FALSE;
	if( memcmp( pMem, segment1_get, segment1_get_len) != 0) return FALSE;
	
		
	//debugtofile("\tsegment 1 found at %.8Xh\n", pMem);
	
	// Make sure that the address in
	//68 5C 40 C7 77             push    offset aPrimary ; "Primary"
	//is really pointing to a "Primary" string
	pPrimaryPtr = (BYTE*) *((DWORD*)(pMemory+segment1_get_len));
	if( memcmp(pPrimaryPtr, primaryString, primaryStringLen) != 0 )
	{
		debugtofile("\t\"Primary\" string not found!\n");
		return FALSE;
	}
	
	//debugtofile("\t\"Primary\" string found at %.8Xh\n", (DWORD)pPrimaryPtr);
	
	// find second segment
	if( IsBadReadPtr( pMem, segment1_get_len+segment2_get_len+0x50) == TRUE ) return FALSE;
	
	pSegment2 = NULL;
	for(n =0; n<segment1_get_len+segment2_get_len+0x50; n++) {
		
		if( memcmp( pMem+n, segment2_get, segment2_get_len) == 0) {
			pSegment2 = pMem+n;
			break;
		}
		
	
	}
		
	if( pSegment2 == NULL ) return FALSE;
	
	//debugtofile("\tsegment 2 found at %.8Xh\n", pSegment2);
	return TRUE;


}


BOOL FindMSV10Functions( DWORD* pdwNlpGetPrimaryCredential,
			DWORD* pdwNlpAddPrimaryCredential,
			DWORD* pdwNlpDeletePrimaryCredential)
{
DWORD ddMSV10_BaseAddress;
MODULEINFO modinfo;
BOOL bRet;
BYTE *pMemory;
unsigned int n;
unsigned nFuncsFound;


	if( pdwNlpGetPrimaryCredential == NULL || pdwNlpAddPrimaryCredential == NULL ||
		pdwNlpDeletePrimaryCredential == NULL) return FALSE;

		
	ddMSV10_BaseAddress = (DWORD)GetModuleHandle("msv1_0.dll");
	if( ddMSV10_BaseAddress == 0 ) {
		//debugtofile("Error finding msv1_0.dll");
		//printf("Error loading msv1_0.dll.\n");
		return FALSE;
	}
	
	bRet = GetModuleInformation( GetCurrentProcess(), 
		(HMODULE)ddMSV10_BaseAddress,
		&modinfo,
		sizeof(modinfo) );
	
	if( bRet == FALSE ) {
			//debugtofile("error in getmoduleinformation");
			//printf("Error in GetModuleInformation.\n");
			return FALSE;
	}
	
	// Look for the functions inside MSV1_0.DLL
	pMemory = (BYTE*)modinfo.lpBaseOfDll;
	
	nFuncsFound = 0;
	for(n = 0; n < (DWORD)modinfo.SizeOfImage; n++)
	{
		
				
		if ( findNlpGetPrimaryCredential( (BYTE*)((DWORD)pMemory+n)) == TRUE )
		{
			//printf("FOUND NlpGetPrimaryCredential at %.8Xh\n", ((DWORD)pMemory+n));
			*pdwNlpGetPrimaryCredential = ((DWORD)pMemory+n);
			nFuncsFound++;
			//debugtofile("GetCredential Found!");
		
		}
		
		if ( findNlpAddPrimaryCredential( (BYTE*)((DWORD)pMemory+n)) == TRUE )
		{
			//printf("FOUND NlpAddPrimaryCredential at %.8Xh\n", ((DWORD)pMemory+n));
			*pdwNlpAddPrimaryCredential = ((DWORD)pMemory+n);
			nFuncsFound++;
			//debugtofile("AddCredential Found!");
		
		}
		if ( findNlpDeletePrimaryCredential( (BYTE*)((DWORD)pMemory+n)) == TRUE )
		{
			//printf("FOUND NlpDeletePrimaryCredential at %.8Xh\n", ((DWORD)pMemory+n));
			*pdwNlpDeletePrimaryCredential = ((DWORD)pMemory+n);
			nFuncsFound++;
			//debugtofile("DeleteCredential Found!");
		
		}
	}
	
	if( nFuncsFound == 3) return TRUE;
	return FALSE;
	
}


