// $Id: injectdll.c,v 1.4 2008/02/25 18:15:13 hochoa Exp $

/*
 * injectdll.c
 *
 * Description: injectdll.c
 *
 * Author: Hernan Ochoa (hochoa@coresecurity.com) (hernan@gmail.com)
 *
 * Copyright (c) 2007-2008 Hernan Ochoa, Buenos Aires, Argentina.
 * All rights reserved.
 *
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES
 * ARE DISCLAIMED. IN NO EVENT SHALL CORE SDI S.A. BE LIABLE FOR ANY
DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY OR CONSEQUENTIAL DAMAGES
 * RESULTING FROM THE USE OR MISUSE OF ANY RECOMPILATION OF THIS SOURCE
 * CODE NOT PROVIDED BY CORE SDI S.A.
 **/

#include <stdio.h>
#include "injectdll.h"


// This is the function used to load the dll in the remote process
static BOOL RemoteFunction (REMOTE_INFO *pInfo)
{
	HINSTANCE hDll;
	pGenFunc_t pGenFunc;
	BOOL bStatus = FALSE;

	hDll = pInfo->pLoadLibrary(pInfo->szDllName);
	if (hDll != NULL)
	{
		pGenFunc = (pGenFunc_t) pInfo->pGetProcAddress(hDll, pInfo->szFunctionName);
		if (pGenFunc != 0)
		{
			bStatus = pGenFunc((REMOTE_INFO*)pInfo->param);
		}
		
                pInfo->pFreeLibrary(hDll);
	}

    return bStatus;
}

// This is just a dummy used to get the address after RemoteFunction
static void DummyFunc ()
{
	return;
}


BOOL InjectDllAndCallFunction(DWORD dwProcPID, char* pszDllName, INJECTDLLANDCALLPARAM* pInjectParams)
{
HANDLE hRemoteProcess, hHandle, hRemoteThread;
REMOTE_INFO remInfo;
DWORD dwRemoteFuncSize, dwParamsSize, dwBytesWritten, dwBytesRead, dwBytesToAlloc, dwIgnored;
BYTE* pRemoteParams, *pRemoteLoader;
BOOL bNoParams;


	if( dwProcPID == 0 || dwProcPID == 0xfffffffff || pszDllName == NULL || pInjectParams == NULL ) return FALSE;
	
	if( pInjectParams->param == NULL || pInjectParams->param_len == 0) {
	
				bNoParams = TRUE;
	
	} else {
		
				bNoParams = FALSE;
	}
	
		
	// Obtain handle to process where to inject DLL
	hRemoteProcess = OpenProcess(PROCESS_ALL_ACCESS, FALSE, dwProcPID);
	if( hRemoteProcess == INVALID_HANDLE_VALUE ) return FALSE;
	
	// Obtain addresses of some functions to use in the remotefunction used
	// to load the DLL in the remote process
	hHandle = LoadLibrary("kernel32.dll");
	remInfo.pLoadLibrary = (pLoadLib_t)GetProcAddress(hHandle, "LoadLibraryA");
	remInfo.pGetProcAddress = (pGetProcAddr_t)GetProcAddress(hHandle, "GetProcAddress");
	remInfo.pFreeLibrary = (pFreeLib_t)GetProcAddress(hHandle, "FreeLibrary");
	
	// Set DLL to load in remote process in REMOTE_INFO 
	memset(remInfo.szDllName, '\x00', BUFFSIZE);
	strncpy(remInfo.szDllName, pszDllName, BUFFSIZE-1);
	remInfo.szDllName[ BUFFSIZE - 1] = '\x00';
	
	// Set Function to call in remote process in REMOTE_INFO
	memset(remInfo.szFunctionName, '\x00', BUFFSIZE);
	strncpy(remInfo.szFunctionName, pInjectParams->functionName, BUFFSIZE-1 );
	remInfo.szFunctionName[ BUFFSIZE - 1] = '\x00';
	
	// Set size in bytes of the block to pass to remote function
	// in REMOTE_INFO. this is not really needed
	pRemoteParams = NULL;
	if( bNoParams == TRUE ) {
		
		remInfo.param_len = 0;
		remInfo.param = NULL;
	}
	else {
		remInfo.param_len = pInjectParams->param_len;
	
		// Alloc in the remote process a buffer to contain the parameters
		// to be received by the remote function
		dwParamsSize = pInjectParams->param_len;
		
		// Allocate memory in remote proc
		pRemoteParams = VirtualAllocEx( hRemoteProcess,NULL, dwParamsSize,
		MEM_COMMIT, PAGE_EXECUTE_READWRITE);
	
		if( pRemoteParams == FALSE ) {
			if( hRemoteProcess ) CloseHandle( hRemoteProcess );
			return FALSE;
		}
		
		// Store address of 'params' buffer 
		remInfo.param = pRemoteParams;
	
		// Copy data to remote process
		if (!WriteProcessMemory(hRemoteProcess, pRemoteParams,
				pInjectParams->param, pInjectParams->param_len,
				&dwBytesWritten) || dwBytesWritten != pInjectParams->param_len)
		{
		
			if( pRemoteParams ) VirtualFreeEx( hRemoteProcess, pRemoteParams, 0, MEM_RELEASE  );
			if( hRemoteProcess) CloseHandle( hRemoteProcess );
			return FALSE;
	
		}
	
	}

	
	
	
	// Determine amount of memory to allocate for 'proxy/loader' function in remote process
	// Determine size of function to copy to remote process that will
	// ultimately load the DLL 
	dwRemoteFuncSize = (DWORD)DummyFunc - (DWORD)RemoteFunction;
	dwBytesToAlloc = dwRemoteFuncSize + sizeof(REMOTE_INFO)+4;
	
	// Alloc loader and loader params
	pRemoteLoader = VirtualAllocEx( hRemoteProcess,NULL, dwBytesToAlloc,
		MEM_COMMIT, PAGE_EXECUTE_READWRITE);
	
	
	if( pRemoteLoader == FALSE ) {
		if( pRemoteParams ) VirtualFreeEx( hRemoteProcess, pRemoteParams, 0, MEM_RELEASE  );
		if( hRemoteProcess ) CloseHandle( hRemoteProcess );
		return FALSE;
	}

	// Copy REMOTE_INFO to remote process
	if (!WriteProcessMemory( hRemoteProcess, pRemoteLoader,
				&remInfo, sizeof(remInfo),
			&dwBytesWritten) || dwBytesWritten != sizeof(remInfo))
	{
		
		if( pRemoteLoader ) VirtualFreeEx( hRemoteProcess, pRemoteLoader, 0, MEM_RELEASE  );
		if( pRemoteParams ) VirtualFreeEx( hRemoteProcess, pRemoteParams, 0, MEM_RELEASE  );
		if( hRemoteProcess ) CloseHandle( hRemoteProcess );
		return FALSE;
	}
	

	// Write loader to remote process
	if (!WriteProcessMemory(hRemoteProcess, (PBYTE)pRemoteLoader + sizeof(REMOTE_INFO) + 4,
				(LPVOID)(DWORD)RemoteFunction, dwRemoteFuncSize, &dwBytesWritten)
			|| dwBytesWritten != dwRemoteFuncSize )
		{
			if( pRemoteLoader ) VirtualFreeEx( hRemoteProcess, pRemoteLoader, 0, MEM_RELEASE  );
			if( pRemoteParams ) VirtualFreeEx( hRemoteProcess, pRemoteParams, 0, MEM_RELEASE  );
			if( hRemoteProcess ) CloseHandle( hRemoteProcess );
			return FALSE;
				
				
		}

	// Create the remote thread to execute loader
	hRemoteThread = CreateRemoteThread( hRemoteProcess, NULL, 0,
		(LPTHREAD_START_ROUTINE)((PBYTE) pRemoteLoader + sizeof(REMOTE_INFO) + 4),
		pRemoteLoader, 0, &dwIgnored);

	if( !hRemoteThread ) {
		if( pRemoteLoader ) VirtualFreeEx( hRemoteProcess, pRemoteLoader, 0, MEM_RELEASE  );
		if( pRemoteParams ) VirtualFreeEx( hRemoteProcess, pRemoteParams, 0, MEM_RELEASE  );
		if( hRemoteProcess ) CloseHandle( hRemoteProcess );
		return FALSE;
	}
	

	// Wait for the thread
	WaitForSingleObject(hRemoteThread, INFINITE);

	// COMMENT: here I add functionality to copy all modifications done to
	// the pRemoteParams block back to the caller. This is kind of a
	// simple and practical way, I think, to return data from the called function
	// without having to setup an IPC channel like a named pipe. This method should
	// work for most uses.
	if( bNoParams == FALSE &&
	   pInjectParams != NULL &&
	   pInjectParams->param != NULL &&
	   pInjectParams->param_len != 0 &&
	   pRemoteParams != NULL) {
		
		if (!ReadProcessMemory(hRemoteProcess, (PBYTE)pRemoteParams,
				 pInjectParams->param, pInjectParams->param_len, &dwBytesRead)
			|| dwBytesRead != pInjectParams->param_len )
		{
			if( pRemoteLoader ) VirtualFreeEx( hRemoteProcess, pRemoteLoader, 0, MEM_RELEASE  );
			if( pRemoteParams ) VirtualFreeEx( hRemoteProcess, pRemoteParams, 0, MEM_RELEASE  );
			if( hRemoteProcess ) CloseHandle( hRemoteProcess );
			return FALSE;
				
		}
		
		
	}
		
	if (hRemoteThread) CloseHandle(hRemoteThread);
	if( pRemoteLoader ) VirtualFreeEx( hRemoteProcess, pRemoteLoader, 0, MEM_RELEASE  );
	if( pRemoteParams ) VirtualFreeEx( hRemoteProcess, pRemoteParams, 0, MEM_RELEASE  );
	if( hRemoteProcess ) CloseHandle( hRemoteProcess );
	
	return TRUE;
	
	
}


BOOL EnableDebugPrivs()
{
	HANDLE hToken = 0;
	TOKEN_PRIVILEGES newPrivs;
	BOOL bStatus = FALSE;

	if (!OpenProcessToken(GetCurrentProcess(), TOKEN_ADJUST_PRIVILEGES,
		&hToken))
	{
		goto clean;
        }

	if (!LookupPrivilegeValue(NULL, SE_DEBUG_NAME, &newPrivs.Privileges[0].Luid))
    {
		goto clean;
	}

	newPrivs.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
	newPrivs.PrivilegeCount = 1;
    
	if (!AdjustTokenPrivileges(hToken, FALSE, &newPrivs, sizeof(TOKEN_PRIVILEGES), NULL, NULL))
	{
		goto clean;
	}

	bStatus = TRUE;

clean:
	if (hToken)
	{
		CloseHandle (hToken);
	}

	return bStatus;	
}
