// $Id: injectdll.h,v 1.2 2008/02/19 15:57:25 hochoa Exp $

/*
 * injectdll.h
 *
 * Description: 
 *
 * Author: Hernan Ochoa (hochoa@coresecurity.com) (hernan@gmail.com)
 *
 * Copyright (c) 2007-2008 Hernan Ochoa, Buenos Aires, Argentina.
 * All rights reserved.
 *
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES
 * ARE DISCLAIMED. IN NO EVENT SHALL CORE SDI S.A. BE LIABLE FOR ANY
DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY OR CONSEQUENTIAL DAMAGES
 * RESULTING FROM THE USE OR MISUSE OF ANY RECOMPILATION OF THIS SOURCE
 * CODE NOT PROVIDED BY CORE SDI S.A.
 **/


#if !defined __INJECTDLL_H__
#define __INJECTDLL_H__

#include <windows.h>



typedef HINSTANCE (WINAPI *pLoadLib_t) (CHAR *);
typedef HINSTANCE (WINAPI *pGetProcAddr_t) (HINSTANCE, CHAR *);
typedef HINSTANCE (WINAPI *pFreeLib_t) (HINSTANCE);

#define BUFFSIZE		1024

#pragma pack(1)
typedef struct _REMOTE_INFO {
	pLoadLib_t pLoadLibrary;
	pGetProcAddr_t pGetProcAddress;
	pFreeLib_t pFreeLibrary;
	CHAR szDllName[BUFFSIZE];
	char szFunctionName[BUFFSIZE];
	BYTE *param;
	unsigned int param_len;
} REMOTE_INFO;


typedef int (*pGenFunc_t) (REMOTE_INFO*);

typedef struct {
    
    char functionName[BUFFSIZE];
    BYTE* param;
    unsigned int param_len;

} INJECTDLLANDCALLPARAM;

BOOL InjectDllAndCallFunction(DWORD dwProcPID, char* pszDllName, INJECTDLLANDCALLPARAM* pInjectParams);
BOOL EnableDebugPrivs(void);

#endif // __INJECTDLL_H__
